#include <stdlib.h>
#include <stdio.h>
#define N	12
#define M0	4
#define M1	1944

typedef struct Row { 
	char r[M0];
} Row;

Row order[N] = {
{{0, 1, -1, -1}},
{{0, 2, -1, -1}},
{{0, 3, -1, -1}},
{{1, 0, -1, -1}},
{{1, 2, -1, -1}},
{{1, 3, -1, -1}},
{{2, 0, -1, -1}},
{{2, 1, -1, -1}},
{{2, 3, -1, -1}},
{{3, 0, -1, -1}},
{{3, 1, -1, -1}},
{{3, 2, -1, -1}}
};

Row rows[M1];
int reqdb[N*N];

#define re(row, ind) ((row).r[(ind)])
#define sre(row, ind, val) (((row).r[(ind)]) = (val))
#define req(a, b) reqdb[a*N + b]

int main()
{
	int rowTotal = 0;
	int i, j, k, l;
   FILE *out;

	for (i = 0; i < N; ++i)
		for (j = 0; j < N; ++j)
			req(i, j) = (re(order[i], 0) == re(order[j], 0));

	for (i = 0; i < N; ++i)
		for (j = 0; j < N; ++j)
			for (k = 0; k < N; ++k)
				for (l = 0; l < N; ++l)
					if (!req(i, j) && !req(i, k) && !req(j, k) && 
						!req(l, i) && !req(l, j) && !req(l, k)) {
						sre(rows[rowTotal], 0, i); sre(rows[rowTotal], 1, j);
						sre(rows[rowTotal], 2, k); sre(rows[rowTotal], 3, l);
						rowTotal++;
					}
	out = fopen("/gentoo/fo/conway/rows", "w");
	for (i = 0; i < rowTotal; ++i) 
		fwrite(rows[i].r, M0, sizeof(char), out);
	fclose(out);
	
 	return 0;
}
